• Prime Path


    The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
    — It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
    — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
    — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
    — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
    — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
    — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

    Now, the minister of finance, who had been eavesdropping, intervened. 
    — No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
    — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
    — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
    1033 
    1733 
    3733 
    3739 
    3779 
    8779 
    8179
    The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

    Input

    One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

    Output

    One line for each case, either with a number stating the minimal cost or containing the word Impossible.

    Sample Input

    3
    1033 8179
    1373 8017
    1033 1033

    Sample Output

    6
    7
    0

    题目大意:多组测试数据。给你两个素数n,m,要求每次只改变n的一个数字,且改变后的数仍然是素数,问经过多少次改变后素数n能变成素数m,输出变化最少的次数
    思路:因为是求最小次数,用bfs可以保证。所以分别枚举个十百千位的数字+素数判定。

    #include <cstdio>
    #include <cstring>
    #include <algorithm>
    #include <cmath>
    #include <queue>
    using namespace std;
    int t,n,m;
    const int N=10010;
    int vis[N];
    struct node
    {
        int x,step;
    };
    queue<node> q;
    int pdss(int n)  //素数判定 
    {
        if(n==0||n==1)
        return 0;
        else if(n==2||n==3)
        return 1;
        for(int i=2;i*i<=n;++i)
        {
            if(n%i==0)
            return 0;
        }
        return 1;
    }
    void bfs()
    {
        int X,STEP,i,k;
        node ss,sss;
        while(!q.empty())
        {
            ss=q.front();
            q.pop();
            X=ss.x;
            STEP=ss.step;
            if(X==m)
            {
                printf("%d
    ",STEP);
                return;
            }
            for(i=1;i<=9;i+=2) 
            {
                k=X/10*10+i;
                if(pdss(k)&&!vis[k]&&k!=X)
                {
                    vis[k]=1;
                    sss.x=k;
                    sss.step=STEP+1;
                    q.push(sss);            
                }
            }
            for(i=0;i<=9;i++) 
            {
                k=X/100*100+i*10+X%10;
                if(pdss(k)&&!vis[k]&&k!=X)
                {
                    vis[k]=1;
                    sss.x=k;
                    sss.step=STEP+1;
                    q.push(sss);            
                }
            }
            for(i=0;i<=9;i++) 
            {
                k=X/1000*1000+i*100+X%100;
                if(pdss(k)&&!vis[k]&&k!=X)
                {
                    vis[k]=1;
                    sss.x=k;
                    sss.step=STEP+1;
                    q.push(sss);            
                }
            }
            for(i=1;i<=9;i++) 
            {
                k=i*1000+X%1000;
                if(pdss(k)&&!vis[k]&&k!=X)
                {
                    vis[k]=1;
                    sss.x=k;
                    sss.step=STEP+1;
                    q.push(sss);            
                }
            }
        }
        printf("Impossible
    ");
        return ;
    }
    int main(int argc, char *argv[])
    {
        scanf("%d",&t);
        while(t--)
        {
            while(!q.empty()) q.pop();
            scanf("%d%d",&n,&m);
            memset(vis,0,sizeof(vis));
            node s;
            s.x=n;
            s.step=0;
            vis[n]=1;
            q.push(s);
            bfs();
        }
        return 0;
    }
  • 相关阅读:
    一步步学习SPD2010--第十三章节--管理SP Server环境的Web内容(2)--理解SP Server2010的Web内容管理
    一步步学习SPD2010--第十三章节--管理SP Server环境的Web内容(1)--创建一个发布网站
    一步步学习SPD2010--第十三章节--管理SP Server环境的Web内容
    一步步学习SPD2010--第十二章节--理解可用性和可接入性(8)--关键点
    亚马逊推自家云备份产品,第三方云备份厂商压力山大 中国存储网
    几何概率模型是什么
    宋浩《概率论与数理统计》笔记---1..1.1-1.1.3、概率论基本概念
    机器学习疑难---1、什么是多元线性回归
    最大似然估计线性回归实例
    Hopfield神经网络 简介
  • 原文地址:https://www.cnblogs.com/Nicholas-Rain/p/10170185.html
Copyright © 2020-2023  润新知